Index: mapstorage.h
===================================================================
--- mapstorage.h	(revision 201)
+++ mapstorage.h	(revision 184)
@@ -22,12 +22,9 @@
 class Mapstorage;
 
-#include <vector>
-#include <map>
-#include <string>
 #include "all_include.h"
 #include "xymap.h"
 #include <libgnomecanvasmm.h>
-#include "map_value.h"
-#include "map_value_map.h"
+
+class NoteBookTab;
 
 ///class MapStorage handles NodeMaps and EdgeMaps.
@@ -48,18 +45,6 @@
   bool background_set;
   double background_scaling;
+  NoteBookTab& mytab;
 public:
-  class Error : public std::exception
-  {
-    private:
-      std::string message;
-    public:
-      Error(const std::string& msg) : message(msg) {}
-      virtual const char* what() const throw()
-      {
-        return message.c_str();
-      }
-      ~Error() throw() {}
-  };
-
   void setBackground(const std::string& file_name);
   const std::string& getBackgroundFilename();
@@ -67,198 +52,10 @@
   double getBackgroundScaling();
   void setBackgroundScaling(double scaling);
-
-  enum MapSaveDest { GUI_SECT, NESET_SECT, DONT_SAVE };
-  enum GuiSectSaveDest { LGF_FILE, CONF_FILE };
-  struct SpecMapSaveOpts
-  {
-    enum Dest { GUI_SECT, NESET_SECT };
-    enum MapNum { ONE_MAP, TWO_MAPS };
-  };
-
-  typedef Graph::NodeMap<double> NumericNodeMap;
-  typedef Graph::NodeMap<std::string> StringNodeMap;
-  typedef Graph::EdgeMap<double> NumericEdgeMap;
-  typedef Graph::EdgeMap<std::string> StringEdgeMap;
-  typedef Graph::NodeMap<int> NodeLabelMap;
-  typedef Graph::EdgeMap<int> EdgeLabelMap;
-  typedef XYMap<Graph::NodeMap<double> > NodeCoordMap;
-  typedef XYMap<Graph::EdgeMap<double> > ArrowCoordMap;
-
-  struct EdgeMapData
-  {
-    /// where to save the map
-    MapSaveDest save_dest;
-    /// read-only or read-write
-    bool writeable;
-    /// default value
-    MapValue default_value;
-    virtual MapValue::Type type() = 0;
-    virtual MapValue get(Edge e) = 0;
-    virtual void set(Edge e, MapValue v) = 0;
-    EdgeMapData(MapValue def_val) :
-      save_dest(GUI_SECT),
-      writeable(true),
-      default_value(def_val)
-    {}
-  };
-
-  struct NumericEdgeMapData : public EdgeMapData
-  {
-    NumericEdgeMap map;
-    MapValue::Type type() { return MapValue::NUMERIC; }
-    MapValue get(Edge e) { return MapValue(map[e]); }
-    void set(Edge e, MapValue v) { map.set(e, static_cast<double>(v)); }
-    NumericEdgeMapData(Graph& g, double def_val) :
-      EdgeMapData(MapValue(def_val)),
-      map(g, def_val)
-    {}
-  };
-
-  struct StringEdgeMapData : public EdgeMapData
-  {
-    StringEdgeMap map;
-    MapValue::Type type() { return MapValue::STRING; }
-    MapValue get(Edge e) { return MapValue(map[e]); }
-    void set(Edge e, MapValue v) { map.set(e, static_cast<std::string>(v)); }
-    StringEdgeMapData(Graph& g, std::string def_val) :
-      EdgeMapData(MapValue(def_val)),
-      map(g, def_val)
-    {}
-  };
-
-  struct NodeMapData
-  {
-    /// where to save the map
-    MapSaveDest save_dest;
-    /// read-only or read-write
-    bool writeable;
-    /// default value
-    MapValue default_value;
-    virtual MapValue::Type type() = 0;
-    virtual MapValue get(Node e) = 0;
-    virtual void set(Node e, MapValue v) = 0;
-    NodeMapData(MapValue def_val) :
-      save_dest(GUI_SECT),
-      writeable(true),
-      default_value(def_val)
-    {}
-  };
-
-  struct NumericNodeMapData : public NodeMapData
-  {
-    NumericNodeMap map;
-    MapValue::Type type() { return MapValue::NUMERIC; }
-    MapValue get(Node e) { return MapValue(map[e]); }
-    void set(Node e, MapValue v) { map.set(e, static_cast<double>(v)); }
-    NumericNodeMapData(Graph& g, double def_val) :
-      NodeMapData(MapValue(def_val)),
-      map(g, def_val)
-    {}
-  };
-
-  struct StringNodeMapData : public NodeMapData
-  {
-    StringNodeMap map;
-    MapValue::Type type() { return MapValue::STRING; }
-    MapValue get(Node e) { return MapValue(map[e]); }
-    void set(Node e, MapValue v) { map.set(e, static_cast<std::string>(v)); }
-    StringNodeMapData(Graph& g, std::string def_val) :
-      NodeMapData(MapValue(def_val)),
-      map(g, def_val)
-    {}
-  };
-
-  typedef std::map<std::string, NodeMapData*> NodeMapStore;
-  typedef std::map<std::string, EdgeMapData*> EdgeMapStore;
-
-  struct GUISectData
-  {
-    std::vector<std::string> main_node_map_names;
-    std::vector<std::string> main_edge_map_names;
-
-    std::vector<std::string> gui_node_map_names;
-    std::vector<std::string> gui_edge_map_names;
-
-    std::map<std::string, MapValue::Type> node_map_types;
-    std::map<std::string, MapValue::Type> edge_map_types;
-
-    std::map<std::string, std::map<int, double>* > numeric_node_maps;
-    std::map<std::string, std::map<int, std::string>* > string_node_maps;
-
-    std::map<std::string, std::map<int, double>* > numeric_edge_maps;
-    std::map<std::string, std::map<int, std::string>* > string_edge_maps;
-
-    std::map<int, XY> node_coord_map;
-    std::map<int, XY> arrow_coord_map;
-
-    SpecMapSaveOpts::Dest node_coords_save_dest;
-    SpecMapSaveOpts::MapNum node_coords_save_map_num;
-    std::string node_coords_one_map_name;
-    std::string node_coords_two_maps_1_name;
-    std::string node_coords_two_maps_2_name;
-
-    SpecMapSaveOpts::Dest arrow_coords_save_dest;
-    SpecMapSaveOpts::MapNum arrow_coords_save_map_num;
-    std::string arrow_coords_one_map_name;
-    std::string arrow_coords_two_maps_1_name;
-    std::string arrow_coords_two_maps_2_name;
-
-    ~GUISectData()
-    {
-      using std::map;
-      using std::vector;
-      using std::pair;
-      using std::string;
-
-      for (map<string, map<int, double>* >::iterator it =
-          numeric_node_maps.begin(); it != numeric_node_maps.end(); ++it)
-      {
-        delete it->second;
-      }
-      for (map<string, map<int, string>* >::iterator it =
-          string_node_maps.begin(); it != string_node_maps.end(); ++it)
-      {
-        delete it->second;
-      }
-      for (map<string, map<int, double>* >::iterator it =
-          numeric_edge_maps.begin(); it != numeric_edge_maps.end(); ++it)
-      {
-        delete it->second;
-      }
-      for (map<string, map<int, string>* >::iterator it =
-          string_edge_maps.begin(); it != string_edge_maps.end(); ++it)
-      {
-        delete it->second;
-      }
-    }
-  };
-public:
   ///The graph for which the datas are stored.
   Graph graph;
-  const Graph& getGraph();
-
-private:
-  GuiSectSaveDest gui_sect_save_dest;
-
-  SpecMapSaveOpts::Dest node_coords_save_dest;
-  SpecMapSaveOpts::MapNum node_coords_save_map_num;
-  SpecMapSaveOpts::Dest arrow_coords_save_dest;
-  SpecMapSaveOpts::MapNum arrow_coords_save_map_num;
-
-  NodeMapStore nodemaps;
-  EdgeMapStore edgemaps;
-
-  NodeLabelMap node_label;
-  EdgeLabelMap edge_label;
-
   /// the coordinates of the nodes
-  NodeCoordMap node_coords;
-  Graph::NodeMap<double> node_coords_x;
-  Graph::NodeMap<double> node_coords_y;
-
+  XYMap<Graph::NodeMap<double> > coords;
   /// the coordinates of the arrows on the edges
-  ArrowCoordMap arrow_coords;
-  Graph::EdgeMap<double> arrow_coords_x;
-  Graph::EdgeMap<double> arrow_coords_y;
+  XYMap<Graph::EdgeMap<double> > arrow_pos;
 
   ///The content of the object has changed, update is needed.
@@ -268,19 +65,10 @@
   std::string file_name;
 
-  // the largest node label
-  int max_node_label;
-
-  // the largest edge label
-  int max_edge_label;
-
-  std::string node_coords_one_map_name;
-  std::string node_coords_two_maps_1_name;
-  std::string node_coords_two_maps_2_name;
-
-  std::string arrow_coords_one_map_name;
-  std::string arrow_coords_two_maps_1_name;
-  std::string arrow_coords_two_maps_2_name;
-
-public:
+  ///Stores double type NodeMaps
+  std::map< std::string,Graph::NodeMap<double> * > nodemap_storage;
+
+  ///Stores double type EdgeMaps
+  std::map< std::string,Graph::EdgeMap<double> * > edgemap_storage;
+
   ///Stores the default values for the different visualization node attributes
   std::vector<Graph::NodeMap<double> > default_nodemaps;
@@ -294,4 +82,12 @@
   /// Stores the active maps for the different visualization edge attributes
   std::vector< std::string > active_edgemaps;
+
+  /// Default values for the maps
+  std::map< std::string, double > nodemap_default;
+
+  /// Default values for the maps
+  std::map< std::string, double > edgemap_default;
+
+  bool arrow_pos_read_ok;
 
 protected:
@@ -308,5 +104,5 @@
   /// std::string is the
   ///name of the new map
-  sigc::signal<void, std::string, MapValue::Type> signal_node_map;
+  sigc::signal<void, std::string> signal_node_map;
 
   /// Signal emitted in the case of edgemap addition
@@ -314,5 +110,5 @@
   /// std::string is the
   ///name of the new map
-  sigc::signal<void, std::string, MapValue::Type> signal_edge_map;
+  sigc::signal<void, std::string> signal_edge_map;
 
   /// Signal emitted, when entry in \ref MapWin should be changed.
@@ -322,7 +118,4 @@
   sigc::signal<void, double, double, int> signal_design_win;
 
-  ///Signal emitted when background should be set by \ref NoteBookTab
-  sigc::signal<void> signal_background;
-
   ///Iteration number during graph design
   int iterations;
@@ -339,5 +132,5 @@
   ///Its all activity is initializing default values
   ///for different visualization attributes.
-  MapStorage();
+  MapStorage(NoteBookTab& tab);
 
   ///Destructor of MapStorage
@@ -374,8 +167,8 @@
 
   /// Returns the names of the edgemaps stored here.
-  std::vector<std::string> getEdgeMapList(MapType type = ALL);
+  std::vector<std::string> getEdgeMapList();
 
   /// Returns the names of the nodemaps stored here.
-  std::vector<std::string> getNodeMapList(MapType type = ALL);
+  std::vector<std::string> getNodeMapList();
 
   ///returns \ref signal_prop to be able to connect functions to it
@@ -383,8 +176,8 @@
 
   ///returns \ref signal_node_map to be able to connect functions to it
-  sigc::signal<void, std::string, MapValue::Type> signal_node_map_ch(){return signal_node_map;};
+  sigc::signal<void, std::string> signal_node_map_ch(){return signal_node_map;};
 
   ///returns \ref signal_edge_map to be able to connect functions to it
-  sigc::signal<void, std::string, MapValue::Type> signal_edge_map_ch(){return signal_edge_map;};
+  sigc::signal<void, std::string> signal_edge_map_ch(){return signal_edge_map;};
 
   ///returns \ref signal_map_win to be able to connect functions to it
@@ -394,14 +187,80 @@
   sigc::signal<void, double, double, int> signal_design_win_ch(){return signal_design_win;};
 
-  void createNodeMap(const std::string& name, MapValue::Type type,
-    MapValue def_val);
-  void createEdgeMap(const std::string& name, MapValue::Type type,
-    MapValue def_val);
-
-  ///returns \ref signal_background to be able to connect functions to it
-  sigc::signal<void> signal_background_ch(){return signal_background;};
-
-
   ///Adds given map to storage.
+
+  ///A name and the map itself has to be provided.
+  ///\param mapname is the name of map
+  ///\param nodemap is the pointer of the given nodemap
+  ///\param def the default value of the map. If not given, it will be 0.
+  ///If new edge is added to graph the value of it in the map will be this.
+  ///\todo map should be given by reference!
+  ///\todo why is default value stored?
+  int addNodeMap(const std::string & mapname,Graph::NodeMap<double> * nodemap, double def=0.0);
+
+  ///Adds given map to storage. A name and the map itself has to be provided.
+
+  ///A name and the map itself has to be provided.
+  ///\param mapname is the name of map
+  ///\param edgemap is the pointer of the given edgemap
+  ///\param def the default value of the map. If not given, it will be 0.
+  ///If new edge is added to graph the value of it in the map will be this.
+  ///\todo map should be given by reference!
+  int addEdgeMap(const std::string & mapname,Graph::EdgeMap<double> * edgemap, double def=0.0);
+
+  ///Returns how much nodemaps is stored in \ref MapStorage
+  int numOfNodeMaps() {return nodemap_storage.size();};
+
+  ///Returns how much edgemaps is stored in \ref MapStorage
+  int numOfEdgeMaps() {return edgemap_storage.size();};
+
+  ///Returns the maximum value of the given NodeMap.
+
+  ///NodeMap has to be given by its name.
+  ///\param name the name of map of which maximum is searched
+  double maxOfNodeMap(const std::string & name);
+
+  ///Returns the maximum value of the given EdgeMap.
+
+  ///EdgeMap has to be given by its name.
+  ///\param name the name of map of which maximum is searched
+  double maxOfEdgeMap(const std::string & name);
+
+  ///Returns the minimum value of the given NodeMap.
+
+  ///NodeMap has to be given by its name.
+  ///\param name the name of map of which minimum is searched
+  double minOfNodeMap(const std::string & name);
+
+  ///Returns the minimum value of the given EdgeMap.
+
+  ///EdgeMap has to be given by its name.
+  ///\param name the name of map of which minimum is searched
+  double minOfEdgeMap(const std::string & name);
+
+  ///Returns iterator pointing to the first NodeMap in storage.
+
+  ///To be able to iterate through each maps this function
+  ///returns an iterator pointing to the first nodemap in
+  ///the storage.
+  std::map< std::string,Graph::NodeMap<double> * >::iterator beginOfNodeMaps(){return nodemap_storage.begin();};
+
+  ///Returns iterator pointing to the first EdgeMap in storage.
+
+  ///To be able to iterate through each maps this function
+  ///returns an iterator pointing to the first edgemap in
+  ///the storage.
+  std::map< std::string,Graph::EdgeMap<double> * >::iterator beginOfEdgeMaps(){return edgemap_storage.begin();};
+
+  ///Returns iterator pointing after the last NodeMap in storage.
+
+  ///To be able to iterate through each maps this function
+  ///returns an iterator pointing to the last nodemap in the storage.
+  std::map< std::string,Graph::NodeMap<double> * >::iterator endOfNodeMaps(){return nodemap_storage.end();};
+
+  ///Returns iterator pointing after the last EdgeMap in storage.
+
+  ///To be able to iterate through each maps this function
+  ///returns an iterator pointing to the last edgemap in the storage.
+  std::map< std::string,Graph::EdgeMap<double> * >::iterator endOfEdgeMaps(){return edgemap_storage.end();};
 
   ///Emits \ref signal_prop if mapvalues have changed, and MapStorage gets to know it.
@@ -425,4 +284,6 @@
   void clear();
 
+  void ArrowPosReadOK();
+
   void get_design_data(double &, double &, int &);
   void set_attraction(double);
@@ -431,99 +292,4 @@
 
   void redesign_data_changed();
-
-  XY getNodeCoords(Node n) const;
-  void setNodeCoords(Node n, XY c);
-  XY getArrowCoords(Edge e) const;
-  void setArrowCoords(Edge e, XY c);
-
-  MapValue get(const std::string& name, Node node) const;
-  void set(const std::string& name, Node node, MapValue val);
-  MapValue get(const std::string& name, Edge edge) const;
-  void set(const std::string& name, Edge edge, MapValue val);
-
-  const std::string& getFileName() const;
-  void setFileName(const std::string& fn);
-
-  bool getModified() const;
-  void setModified(bool m = true);
-
-  Node addNode(XY);
-  Edge addEdge(Node, Node);
-
-  NumericNodeMap& getNumericNodeMap(const std::string& name);
-  StringNodeMap& getStringNodeMap(const std::string& name);
-  NumericEdgeMap& getNumericEdgeMap(const std::string& name);
-  StringEdgeMap& getStringEdgeMap(const std::string& name);
-
-  MapValueEdgeMap getEdgeMap(const std::string& name);
-  MapValueNodeMap getNodeMap(const std::string& name);
-
-  int getLabel(Node) const;
-  int getLabel(Edge) const;
-
-  GuiSectSaveDest getGUIDataSaveLocation();
-  void setGUIDataSaveLocation(GuiSectSaveDest dest);
-
-  MapSaveDest getNodeMapSaveDest(std::string name) const;
-  MapSaveDest getEdgeMapSaveDest(std::string name) const;
-  void setNodeMapSaveDest(std::string name, MapSaveDest dest);
-  void setEdgeMapSaveDest(std::string name, MapSaveDest dest);
-
-  SpecMapSaveOpts::Dest getNodeCoordsSaveDest();
-  SpecMapSaveOpts::Dest getArrowCoordsSaveDest();
-  void setNodeCoordsSaveDest(SpecMapSaveOpts::Dest dest);
-  void setArrowCoordsSaveDest(SpecMapSaveOpts::Dest dest);
-
-  SpecMapSaveOpts::MapNum getNodeCoordsSaveMapNum();
-  SpecMapSaveOpts::MapNum getArrowCoordsSaveMapNum();
-  void setNodeCoordsSaveMapNum(SpecMapSaveOpts::MapNum num);
-  void setArrowCoordsSaveMapNum(SpecMapSaveOpts::MapNum num);
-
-  MapValue::Type getNodeMapElementType(std::string name) const;
-  MapValue::Type getEdgeMapElementType(std::string name) const;
-
-  const NodeLabelMap& getNodeLabelMap();
-  const EdgeLabelMap& getEdgeLabelMap();
-
-  bool nodeMapExists(std::string name);
-  bool edgeMapExists(std::string name);
-
-  std::vector<std::string> getEdgeMaps(MapType type = ALL);
-  std::vector<std::string> getNodeMaps(MapType type = ALL);
-
-  NodeCoordMap& getNodeCoordMap();
-  ArrowCoordMap& getArrowCoordMap();
-
-  const std::string& getNodeCoordsOneMapName();
-  const std::string& getNodeCoordsTwoMaps1Name();
-  const std::string& getNodeCoordsTwoMaps2Name();
-  void setNodeCoordsOneMapName(const std::string& name);
-  void setNodeCoordsTwoMaps1Name(const std::string& name);
-  void setNodeCoordsTwoMaps2Name(const std::string& name);
-
-  const std::string& getArrowCoordsOneMapName();
-  const std::string& getArrowCoordsTwoMaps1Name();
-  const std::string& getArrowCoordsTwoMaps2Name();
-  void setArrowCoordsOneMapName(const std::string& name);
-  void setArrowCoordsTwoMaps1Name(const std::string& name);
-  void setArrowCoordsTwoMaps2Name(const std::string& name);
-
-private:
-  EdgeMapData* getEdgeMapData(std::string name) const;
-  NodeMapData* getNodeMapData(std::string name) const;
-  void readLGF(
-      const std::string& filename,
-      bool read_edge_label,
-      const std::vector<std::string>& node_map_names,
-      const std::vector<std::string>& edge_map_names,
-      const std::map<std::string, MapValue::Type>& node_map_types,
-      const std::map<std::string, MapValue::Type>& edge_map_types,
-      const std::string& node_coord_xmap_name,
-      const std::string& node_coord_ymap_name,
-      const std::string& arrow_coord_xmap_name,
-      const std::string& arrow_coord_ymap_name);
-
-public:
-  void exportGraphToEPS(std::vector<bool>, std::string, std::string);
 };
 
Index: nbtab.cc
===================================================================
--- nbtab.cc	(revision 201)
+++ nbtab.cc	(revision 186)
@@ -18,18 +18,8 @@
 
 #include <nbtab.h>
-#include <mapstorage.h>
-#include <eps_win.h>
-#include <map_win.h>
-#include <design_win.h>
-#include <graph_displayer_canvas.h>
-
-
-
-NoteBookTab::NoteBookTab():mapwinexists(false), designwinexists(false), epswinexists(false)
-{
-  mapstorage=new MapStorage();
-
+
+NoteBookTab::NoteBookTab():mapwinexists(false), designwinexists(false), mapstorage(*this)
+{
   Gtk::ScrolledWindow *pScrolledWindow = manage(new Gtk::ScrolledWindow);
-  pScrolledWindow->set_shadow_type(Gtk::SHADOW_ETCHED_IN);
   gd_canvas=new GraphDisplayerCanvas(*this);
   pScrolledWindow->add(*gd_canvas);
@@ -37,8 +27,7 @@
 
   //connecting signals - controller character
-  mapstorage->signal_prop_ch().connect(sigc::mem_fun(*gd_canvas, &GraphDisplayerCanvas::propertyChange));
-  mapstorage->signal_node_map_ch().connect(sigc::mem_fun(*this, &NoteBookTab::registerNewNodeMap));
-  mapstorage->signal_edge_map_ch().connect(sigc::mem_fun(*this, &NoteBookTab::registerNewEdgeMap));
-  mapstorage->signal_background_ch().connect(sigc::mem_fun(*gd_canvas, &GraphDisplayerCanvas::setBackground));
+  mapstorage.signal_prop_ch().connect(sigc::mem_fun(*gd_canvas, &GraphDisplayerCanvas::propertyChange));
+  mapstorage.signal_node_map_ch().connect(sigc::mem_fun(*this, &NoteBookTab::registerNewNodeMap));
+  mapstorage.signal_edge_map_ch().connect(sigc::mem_fun(*this, &NoteBookTab::registerNewEdgeMap));
   show_all_children();
   show();
@@ -47,22 +36,18 @@
 void NoteBookTab::readFile(const std::string &file)
 {
-  mapstorage->readFromFile(file);
-  mapstorage->setFileName(file);
-  mapstorage->setModified(false);
+  mapstorage.readFromFile(file);
+  mapstorage.file_name = file;
+  mapstorage.modified = false;
   gd_canvas->drawGraph();
   if(mapwinexists)
     {
-      mapwin->update(
-          mapstorage->getEdgeMapList(NUM),
-          mapstorage->getEdgeMapList(STR),
-          mapstorage->getNodeMapList(NUM),
-          mapstorage->getNodeMapList(STR));
-    }
-  title_changed(Glib::filename_display_basename(file));
+      mapwin->update(mapstorage.getEdgeMapList(), mapstorage.getNodeMapList());
+    }
+  signal_title.emit(Glib::filename_display_basename(file));
 }
 
 void NoteBookTab::newFile()
 {
-  if (mapstorage->getModified())
+  if (mapstorage.modified)
   {
     Gtk::MessageDialog mdialog("<b>Save changes before closing?</b>", true,
@@ -83,19 +68,15 @@
   }
   gd_canvas->clear();
-  mapstorage->clear();
-  if(mapwinexists)
-    {
-      mapwin->update(
-          mapstorage->getEdgeMapList(NUM),
-          mapstorage->getEdgeMapList(STR),
-          mapstorage->getNodeMapList(NUM),
-          mapstorage->getNodeMapList(STR));
-    }
-  title_changed("unsaved file");
+  mapstorage.clear();
+  if(mapwinexists)
+    {
+      mapwin->update(mapstorage.getEdgeMapList(), mapstorage.getNodeMapList());
+    }
+  signal_title.emit("unsaved file");
 }
 
 void NoteBookTab::openFile()
 {
-  if (mapstorage->getModified())
+  if (mapstorage.modified)
   {
     Gtk::MessageDialog mdialog("<b>Save changes before closing?</b>", true, 
@@ -121,20 +102,16 @@
   {
     gd_canvas->clear();
-    mapstorage->clear();
+    mapstorage.clear();
     Glib::ustring filename = fcdialog.get_filename();
-    if (!mapstorage->readFromFile(filename))
-    {
-      mapstorage->setFileName(filename);
-      mapstorage->setModified(false);
+    if (!mapstorage.readFromFile(filename))
+    {
+      mapstorage.file_name = filename;
+      mapstorage.modified = false;
       gd_canvas->drawGraph();
       if(mapwinexists)
 	{
-          mapwin->update(
-              mapstorage->getEdgeMapList(NUM),
-              mapstorage->getEdgeMapList(STR),
-              mapstorage->getNodeMapList(NUM),
-              mapstorage->getNodeMapList(STR));
+	  mapwin->update(mapstorage.getEdgeMapList(), mapstorage.getNodeMapList());
 	}
-      title_changed(Glib::filename_display_basename(filename));
+      signal_title.emit(Glib::filename_display_basename(filename));
     }
   }
@@ -143,12 +120,12 @@
 void NoteBookTab::saveFile()
 {
-  if (mapstorage->getFileName() == "") {
+  if (mapstorage.file_name == "") {
     saveFileAs();
   }
   else
   {
-    mapstorage->writeToFile(mapstorage->getFileName());
-    mapstorage->setModified(false);
-    title_changed(Glib::filename_display_basename(mapstorage->getFileName()));
+    mapstorage.writeToFile(mapstorage.file_name);
+    mapstorage.modified = false;
+    signal_title.emit(Glib::filename_display_basename(mapstorage.file_name));
   }
 }
@@ -162,8 +139,8 @@
   {
     Glib::ustring filename = fcdialog.get_filename();
-    mapstorage->setFileName(filename);
-    mapstorage->writeToFile(filename);
-    mapstorage->setModified(false);
-    title_changed(Glib::filename_display_basename(filename));
+    mapstorage.file_name = filename;
+    mapstorage.writeToFile(filename);
+    mapstorage.modified = false;
+    signal_title.emit(Glib::filename_display_basename(filename));
   }
 }
@@ -171,5 +148,5 @@
 void NoteBookTab::close()
 {
-  if (mapstorage->getModified())
+  if (mapstorage.modified)
   {
     Gtk::MessageDialog mdialog("<b>Save changes before closing?</b>", true,
@@ -190,19 +167,15 @@
   }
   gd_canvas->clear();
-  mapstorage->clear();
-  if(mapwinexists)
-    {
-      mapwin->update(
-          mapstorage->getEdgeMapList(NUM),
-          mapstorage->getEdgeMapList(STR),
-          mapstorage->getNodeMapList(NUM),
-          mapstorage->getNodeMapList(STR));
-    }
-  title_changed("unsaved file");
+  mapstorage.clear();
+  if(mapwinexists)
+    {
+      mapwin->update(mapstorage.getEdgeMapList(), mapstorage.getNodeMapList());
+    }
+  signal_title.emit("unsaved file");
 }
 
 void NoteBookTab::propertyChange(bool itisedge, int prop, std::string mapname)
 {
-  mapstorage->changeActiveMap(itisedge, prop, mapname);
+  mapstorage.changeActiveMap(itisedge, prop, mapname);
 }
 
@@ -219,29 +192,25 @@
 std::string NoteBookTab::getActiveEdgeMap(int prop)
 {
-  return mapstorage->getActiveEdgeMap(prop);
+  return mapstorage.getActiveEdgeMap(prop);
 }
 
 std::string NoteBookTab::getActiveNodeMap(int prop)
 {
-  return mapstorage->getActiveNodeMap(prop);
-}
-
-void NoteBookTab::registerNewEdgeMap(std::string mapname, MapValue::Type type)
-{
-  if(mapwinexists)
-    {
-      mapwin->registerNewEdgeMap(mapname, type);
-    }
-}
-
-void NoteBookTab::registerNewNodeMap(std::string mapname, MapValue::Type type)
-{
-  if(mapwinexists)
-    {
-      mapwin->registerNewNodeMap(mapname, type);
-    }
-  if(epswinexists)
-    {
-      epswin->registerNewNodeMap(mapname, type);
+  return mapstorage.getActiveNodeMap(prop);
+}
+
+void NoteBookTab::registerNewEdgeMap(std::string mapname)
+{
+  if(mapwinexists)
+    {
+      mapwin->registerNewEdgeMap(mapname);
+    }
+}
+
+void NoteBookTab::registerNewNodeMap(std::string mapname)
+{
+  if(mapwinexists)
+    {
+      mapwin->registerNewNodeMap(mapname);
     }
 }
@@ -251,11 +220,6 @@
   if(!mapwinexists)
     {
-      mapwin=new MapWin("Map Setup - "+name,
-          mapstorage->getEdgeMapList(NUM),
-          mapstorage->getEdgeMapList(STR),
-          mapstorage->getNodeMapList(NUM),
-          mapstorage->getNodeMapList(STR),
-          *this);
-      mapst2mapwin=mapstorage->signal_map_win_ch().connect(sigc::mem_fun(*mapwin, &MapWin::changeEntry));
+      mapwin=new MapWin("Map Setup - "+name, mapstorage.getEdgeMapList(), mapstorage.getNodeMapList(), *this);
+      mapst2mapwin=mapstorage.signal_map_win_ch().connect(sigc::mem_fun(*mapwin, &MapWin::changeEntry));
       mapwin->show();
       mapwinexists=true;
@@ -263,18 +227,4 @@
 }
 
-void NoteBookTab::createExportToEPSWin(std::string name)
-{
-  if(!epswinexists)
-    {
-      epswin=new EpsWin("Export to EPS - "+name, mapstorage->getNodeMapList(NUM), mapstorage->getNodeMapList(STR));
-      epswin->show();
-      epswinexists=true;
-      epswin->signal_eps_details_ch().connect(sigc::mem_fun(*this, &NoteBookTab::exportGraphToEPS));
-      epswin->signal_eps_close_ch().connect(sigc::mem_fun(*this, &NoteBookTab::closeEpsWin));
-      epswin->signal_new_map_ch().connect(sigc::mem_fun(*this, &NoteBookTab::popupNewMapWin));
-    }
-}
-
-
 void NoteBookTab::createDesignWin(std::string name)
 {
@@ -283,15 +233,15 @@
       double attraction, propulsation;
       int iterations;
-      mapstorage->get_design_data(attraction, propulsation, iterations);
-      designwin=new DesignWin("Design Setup - "+name, attraction, propulsation, iterations);
-
-      designwin->signal_attraction().connect(sigc::mem_fun(*mapstorage, &MapStorage::set_attraction));
-      designwin->signal_propulsation().connect(sigc::mem_fun(*mapstorage, &MapStorage::set_propulsation));
-      designwin->signal_iteration().connect(sigc::mem_fun(*mapstorage, &MapStorage::set_iteration));
+      mapstorage.get_design_data(attraction, propulsation, iterations);
+      designwin=new DesignWin("Design Setup - "+name, attraction, propulsation, iterations, *this);
+
+      designwin->signal_attraction().connect(sigc::mem_fun(mapstorage, &MapStorage::set_attraction));
+      designwin->signal_propulsation().connect(sigc::mem_fun(mapstorage, &MapStorage::set_propulsation));
+      designwin->signal_iteration().connect(sigc::mem_fun(mapstorage, &MapStorage::set_iteration));
       designwin->close_run().connect(sigc::mem_fun(*gd_canvas, &GraphDisplayerCanvas::reDesignGraph));
 
       designwin->signal_delete_event().connect(sigc::mem_fun(*this, &NoteBookTab::closeDesignWin));
 
-      mapst2designwin=mapstorage->signal_design_win_ch().connect(sigc::mem_fun(*designwin, &DesignWin::set_data));
+      mapst2designwin=mapstorage.signal_design_win_ch().connect(sigc::mem_fun(*designwin, &DesignWin::set_data));
 
       designwin->show();
@@ -307,10 +257,4 @@
 }
 
-void NoteBookTab::closeEpsWin()
-{
-  epswinexists=false;
-  delete epswin;
-}
-
 bool NoteBookTab::closeDesignWin(GdkEventAny * e)
 {
@@ -345,22 +289,4 @@
 void NoteBookTab::active_maps_needed()
 {
-  mapstorage->broadcastActiveMaps();
-}
-
-void NoteBookTab::exportGraphToEPS(std::vector<bool> options, std::string filename, std::string shapemap)
-{
-  mapstorage->exportGraphToEPS(options, filename, shapemap);
-}
-
-void NoteBookTab::title_changed(std::string newtitle)
-{
-  signal_title.emit(newtitle);
-  if(epswinexists)
-    {
-      epswin->set_title(newtitle);
-    }
-  if(designwinexists)
-    {
-      designwin->set_title(newtitle);
-    }
-}
+  mapstorage.broadcastActiveMaps();
+}
